#! /usr/local/bin/ruby -Ke

require "ncurses"
require "constant"
require "keyconvert"
require "utility"
require "kconv"

class Client

  include Constant::Client
  include Constant::Object
  include Constant::Monster
  include Keyconvert
  include Ncurses
  include Utility

  attr_accessor :player
  attr_reader :name

  def initialize( name )
    
    @name   = name
    @player = nil
   
    @screen = nil
       
    # 3l(3ⱦ)䡢H()Ȥäޥɤ
    # Server¦ǤϥݡȤʤΤǡClient¦ǥߥ졼Ȥޤ
    # ӤǤ

    # 10lȤäϤʤ줿ݤˤϡ
    # @multi_com = ?l
    # @multi_times = 10
    # ȡᤵޤ
    
    @multi_com   = nil 
    @multi_times = 0
    
    # Ncurses
    
    Ncurses.initscr
    Ncurses.noecho
    Ncurses.cbreak
    
    # ѥͥꡣ

    @ranking = makepanel( DROWS, DCOLS, 0, 0 )
    @ranking.hide
    
    @mail    = makepanel( DROWS, DCOLS, 0, 0 )
    @mail.hide
    
    @ending  = makepanel( DROWS, DCOLS, 0, 0 )
    @ending.hide
    
    @message = makepanel( DROWS, DCOLS, 0, 0 )
    
    @main    = makepanel( MAXY + 3, DCOLS, 0, 0 )
    Ncurses.wattroff( @main.window, A_BOLD )
    
    @store_message = nil
    @store_main    = nil
    
    @help = nil

    myupdate

  end
  
  def myupdate
    Panel.update
    Ncurses.doupdate
  end
  
  def makepanel( rows, cols, r_offset, c_offset )

    win = WINDOW.new( rows, cols, 0, 0 )
    Ncurses.wattron( win, A_BOLD )
    
    panel = Panel::PANEL.new( win )
    panel.move( r_offset, c_offset )

    Ncurses.scrollok( win, true )
    Ncurses.keypad( win, true )
  
    panel

  end
  
  GO_DIRECT = {
    :magic_missile? => "+",
    :sonic_spear?   => "@",
    :fireball?      => "*",
    :cold?          => "O",
    :lightning?     => "~",
  }

  OMNI_DIRECT = {
    :cloud_kill? => "'",
    :flood?      => "~",
    :magic_fire? => "*",
  }
  
  def magic_attack( spell, point )

    row, col = point
    s_time = 0

    window = @main.window
    Ncurses.wattron( window, A_BLINK )
    
    if ( k_v = GO_DIRECT.find{ | symbol, | spell.send( symbol ) } )
      
      Ncurses.mvwaddch( window, row, col, k_v[ 1 ][ 0 ] ) 
      s_time = 0.08
      
    elsif ( k_v = OMNI_DIRECT.find{ | symbol, | spell.send( symbol ) } )

      # point濴ȤȾ1ϰˡˡ̤ȯ롣

      ( row - 1 ).upto( row + 1 ) do | r |
	( col - 1 ).upto( col + 1 ) do | c |
	  next if out_of_dungeon?( [ r, c ] )
	  Ncurses.mvwaddch( window, r, c, k_v[ 1 ][ 0 ] )
	end
      end
      
      s_time = 4
      
    end

    Ncurses.wattroff( window, A_BLINK )
    
    cursor_to_player
    myupdate
    sleep( s_time )
    
  end
  
  def mygetc
    Ncurses.flushinp
    Ncurses.getch
  end

  def hide_main

    @main.hide
    Ncurses.redrawwin( @message.window ) if $REDRAW
    myupdate
    mygetc
    @main.show
    myupdate

  end

  def multi_move_check

    # ¿ϤꤵƤʤޤϲλ鵶
    return false if !@multi_com || ( ( @multi_times -= 1 ) < 0 )

    # ᤯˥󥹥뤫ɤ?
    return true unless @screen

    p_point = @screen.players.keys[ 0 ]
    
    if @screen.monsters.find { | m_point, | distance( p_point, m_point ) <= 4 }
      @multi_times = 0
      return false
    end

    return true unless DIRS.include?( @multi_com )
    
    # Ԥ˥֥ȤˤϡȤꤢߤޤ餻롣
    n_point = next_point( p_point, @multi_com )
    
    if @screen.objects.key?( n_point )
      @multi_times = 0
      return false
    end

    # ϷŪ˻ߤޤäɤ硣ƻʬʤɡ

    if better_to_stop?( p_point, n_point, @multi_com )
      @multi_times = 0
      return false
    end
    
    true
    
  end

  # ʲΤ褦ʾˤϡ¿ưߤ롣
  # ǤʤˤʤळȤΤǡ
  
  # 
  # 
  #   

  # Τ褦ʾˤ³ԡ
  # ̵롣
  
  #
  # 
  #     
  #   

  # ξˤ³ԡʤɤʤϤǤ

  #
  #    
  #   
  # 

  DIR2SIDE = {
    ?h => [ ?y, ?b ],
    ?j => [ ?b, ?n ],
    ?k => [ ?y, ?u ],
    ?l => [ ?u, ?n ],
    ?y => [ ?h, ?k ],
    ?u => [ ?k, ?l ],
    ?b => [ ?h, ?j ],
    ?n => [ ?l, ?j ],
  }

  NARUTO2SIDE = {
    ?h => [ ?k, ?j ],
    ?j => [ ?h, ?l ],
    ?k => [ ?h, ?l ],
    ?l => [ ?k, ?j ],
    ?y => [ ?u, ?b ],
    ?u => [ ?y, ?n ],
    ?b => [ ?y, ?n ],
    ?n => [ ?u, ?b ],
  }

  def can_move_to_dirs?( point, dirs )
    dirs.find { | dir | can_move_to?( next_point( point, dir ) ) } 
  end

  
  def better_to_stop?( from, to, dir )
    
    return true  unless can_move_to?( to )
    return false if can_move_to_dirs?( from, NARUTO2SIDE[ dir ] )

    can_move_to_dirs?( from, DIR2SIDE[ dir ] )

  end

  def can_move_to?( point )
    !out_of_dungeon?( point ) && ( @screen.maze[ point[ 0 ] ][ point[ 1 ] ] != OWALL )
  end
  
  def distance( from, to )
    [ ( from[ 0 ] - to[ 0 ] ).abs, ( from[ 1 ] - to[ 1 ] ).abs ].max
  end
  
  
  # ޥɤϤ¥
  def command

    sleep 0.1
    
    cursor_to_player
    myupdate
    
    return @multi_com if multi_move_check

    num = 0
    
    loop do

      if ( com = mygetc ).between?( ?0, ?9 ) && !CONVERT.key?( com )
	num = num * 10 + ( com - ?0 )
	next
      end
      
      next unless ( @multi_com = CONVERT[ com ] )

      if com == ?\t
	hide_main
	num = 0
	next
      end

      if MULTI_MOVE.include?( com )
	@multi_com   = multi2one( @multi_com )
	@multi_times = 100
      elsif MULTI_COM.include?( @multi_com )
	@multi_com   = com
	@multi_times = num 
      end

      return @multi_com
      
    end
            
  end

  def test 

  end
  
  def newcavelevel( screen, volcano )
    @screen = screen
    @volcano = volcano
    @multi_times = 0
  end
  
  def drawscreen( screen, to_update = true ) # 󥸥ʬ衣

    Ncurses.werase( @main.window )

    0.upto( MAXY - 1 ) do | row |
      0.upto( MAXX - 1 ) do | col |
	showpoint( screen, row, col )
      end
    end

    cursor_to_player
    myupdate if to_update
    
  end

  def cursor_to_player

    return unless @screen
    return unless ( point = @screen.players.keys[ 0 ] )
    
    Ncurses.wmove( @main.window, *point )
        
  end

  
  # ( row, col )濴ˤơȾradiusΥꥢԤ
  def showcell( screen, point, radius )
    
    row, col = point

    # drawscreen( @screen, false ) if @screen

    # Ncurses.wattron( @main.window, A_BOLD )

    ( row - radius ).upto( row + radius ) do | r |
      next if ( r < 0 ) || ( r > MAXY - 1 )
      ( col - radius ).upto( col + radius ) do | c |
	next if ( c < 0 ) || ( c > MAXX - 1 )
	showpoint( screen, r, c )
      end
    end

    # Ncurses.wattroff( @main.window, A_BOLD )

    cursor_to_player
      
  end

  def showpoint( screen, row, col )

    # ͥ٤ϡ
    # 1: 󥹥ץ쥤䡼
    # 2: ֥
    # 3: ϩ
    # ν硣

    point  = [ row, col ]
    window = @main.window 
    
    if mon = screen.monsters[ point ]
      Ncurses.mvwaddch( window, row, col, MONCHAR[ mon ] )
    elsif player = screen.players[ point ]
      Ncurses.mvwaddch( window, row, col, ?@ )
    elsif obj = screen.objects[ point ]
      Ncurses.wattron( window, A_REVERSE )
      Ncurses.mvwaddch( window, row, col, OBJCHAR[ obj ] )
      Ncurses.wattroff( window, A_REVERSE )
    elsif sphere = screen.spheres[ point ]
      Ncurses.wattron( window, A_BLINK )
      Ncurses.mvwaddch( window, row, col, sphere )
      Ncurses.wattroff( window, A_BLINK )
    elsif ( maze = screen.maze[ row ][ col ] ) == OWALL
      Ncurses.mvwaddch( window, row, col, OBJCHAR[ maze ] )
    else
      Ncurses.mvwaddch( window, row, col, ?\s )
    end

  end

  def close
    Ncurses.endwin
  end

  def status_routine( row, str )
    Ncurses.wattron( @main.window, A_BLINK | A_BOLD | A_UNDERLINE )
    Ncurses.mvwaddstr( @main.window, row, 0, sprintf( "%-80s", str ) )
    Ncurses.wredrawln( @main.window, row, 1 )
    Ncurses.wattroff( @main.window, A_BLINK | A_BOLD | A_UNDERLINE )
  end
  
  def status1( format1, status_array )
    status_routine( MAXY, sprintf( format1, *status_array ) )
  end

  def status2( format2, status_array )
    status_routine( MAXY + 1, sprintf( format2, *status_array ) )
  end

  def my_scroll( panel, num = 1 )

    Ncurses.wscrl( panel.window, num )
    Ncurses.redrawwin( panel.window ) if $REDRAW
  
  end
  
  def m_scroll( num = 1 )
    
    Ncurses.wscrl( @message.window, num )
    Ncurses.wredrawln( @message.window, MAXY + 2, DROWS - MAXY - 2 ) if $REDRAW

  end

  def version( arg )

    m_scroll( arg.size )
    window = @message.window
    
    arg.each_with_index do | line, i |
      Ncurses.mvwaddstr( window, DROWS - arg.size + i, 0, line )
    end
    
    Ncurses.redrawwin( window ) if $REDRAW
    
    cursor_to_player
    myupdate
        
  end

  IFORMAT1 = "%s)   %s"
  IFORMAT2 = " + %-2d"
  IFORMAT3 = " - %-2d"
  IFORMAT4 = " (%s)"
  MFORMAT  = "%s)   %d %s"

  def format2str( iformat )

    if iformat[ 0 ] == "."
      return( sprintf( MFORMAT, iformat[ 0 ], iformat[ 2 ], iformat[ 1 ] ) )
    end
    
    str = sprintf( IFORMAT1, *iformat )

    if iformat[ 2 ] && ( iformat[ 2 ] != 0 )
      str << sprintf( ( iformat[ 2 ] < 0 ) ? IFORMAT3 : IFORMAT2,
		     iformat[ 2 ].abs )
    end

    if iformat[ 3 ]
      str << sprintf( IFORMAT4, iformat[ 3 ] )
    end

    str
      
  end
  
  def item( item_format )
    message( format2str( item_format ) )
  end

  def select( select_mesg, list, press_space, abort )

    message( select_mesg )

    loop do
      
      if ( com = mygetc ) == ?*
	if ( char = itemlist( list, press_space ) ) ; return char ; end
	next
      end

      if com == ?\e
	Ncurses.waddstr( @message.window,  abort )
	cursor_to_player
	myupdate
      end

      return com
      
    end

  end

  def write_press_space( window, row, press_space )

    Ncurses.wmove( window, row, 0 )
    
    press_space.each_with_index do | str, i |
      Ncurses.wattron( window, A_REVERSE ) if i == 1
      Ncurses.waddstr( window, str ) if str 
      Ncurses.wattroff( window, A_REVERSE ) if i == 1
    end
    
  end

  def itempage( panel, to_write, press_space )

    # WINDOWޤ뤴ȼؤܸβʤ?
    panel.replace( win = WINDOW.new( to_write.size + 1, DCOLS, 0, 0 ) )
    Ncurses.wattron( win, Ncurses::A_BOLD )
    Ncurses.redrawwin( win ) if $REDRAW
    
    to_write.each_with_index do | string, i |
      Ncurses.mvwaddstr( win, i, 0, string )
    end
    
    write_press_space( panel.window, to_write.size, press_space )
    myupdate

    ( com = mygetc ).between?( ?a, ?z ) ? com : nil

  end
    
  def itemlist( iarray, press_space, time = nil )

    # item_arrayΥϡ⡹ ( 26 + 1 )

    to_write = iarray.collect{ | format | format2str( format ) }
    to_write.push( time ) if time

    first  = ( ( to_write.size > DROWS - 1 )? DROWS - 1 : to_write.size )
    second = to_write.size - first 

    panel = makepanel( DROWS, DCOLS, 0, 0 )
    
    if com = itempage( panel, to_write[ 0, first ], press_space )
      panel.del
      myupdate
      return( com ) 
    end
    
    if ( second > 0 )
      com = itempage( panel, to_write[ first, second ], press_space )  
    end

    panel.del
    myupdate

    com
    
  end

  def all_item( item_array, time_format, elapsed, left, press_space )

    itemlist( item_array, press_space, sprintf( time_format, elapsed, left ) )

  end
    
  def message( str, cursor = true )

    m_scroll
    Ncurses.mvwaddstr( @message.window,  DROWS - 1, 0, str ) if str

    multi_cancel
    Ncurses.redrawwin( @message.window ) if $REDRAW
    
    cursor_to_player if cursor
    myupdate
    
  end

  def investigate_message( str )
    message( str, false )
  end

  
  def statue_message( str )

    m_scroll( 2 )
    multi_cancel
    Ncurses.mvwaddstr( @message.window, DROWS - 1, 0, str ) if str
    cursor_to_player
    myupdate
        
  end

  alias_method( :mirror_message, :statue_message )
  alias_method( :pit_message,    :statue_message )
  
  def s_scroll
    my_scroll( @store_message )
  end
  
  def store_message( str )

    s_scroll
    Ncurses.mvwaddstr( @store_message.window, DROWS - 1, 0, str ) if str

    myupdate
    
  end

  def add_message( str )

    Ncurses.waddstr( @message.window, str ) if str
    cursor_to_player
    myupdate

  end

  def reach_question( find_str, select_str, choice )
    
    m_scroll( 3 )
    window = @message.window
    
    Ncurses.mvwaddstr( window, DROWS - 2, 0, find_str )
    Ncurses.mvwaddstr( window, DROWS - 1, 0, select_str )
    myupdate
    
    multi_cancel
    
    loop do
      
      next unless choice.key?( com = mygetc )
      
      Ncurses.waddstr( window, choice[ com ] )
      myupdate

      return com

    end
    
  end
  
  def question( str, choice )

    message( str )

    loop do
      
      next unless choice.key?( com = mygetc )

      Ncurses.waddstr( @message.window, choice[ com ] )
      myupdate

      return com

    end
    
  end

  def quit_question( question, answer, second_question )

    message( question )

    loop do

      if answer.key?( com = mygetc )
	Ncurses.waddstr( @message.window,  answer[ com ] )
	myupdate

	return com

      end

      m_scroll

      win = @message.window
      win.move( DROWS - 1, 0 )

      second_question.each_with_index do | string, i |
	Ncurses.wattron( win, A_REVERSE ) if i == 0 || i == 2 
	Ncurses.waddstr( win, string )
	Ncurses.wattroff( win, A_REVERSE ) if i == 0 || i == 2
      end

      myupdate
      
    end
    
  end

  def home( home_mesg, press_mesg, modulo )

    panel  = makepanel( DROWS, DCOLS, 0, 0 )
    window = panel.window

    Ncurses.wattron( window, A_BOLD )
    
    home_mesg.each_with_index do | mesg, i |
      next if !mesg || mesg.size == 0
      Ncurses.mvwaddstr( window, i, 0,
		  sprintf( mesg, ( mesg =~ /%d/ ) ? modulo : @name ) )
      
    end

    Ncurses.wmove( window, home_mesg.size, 0 )
    
    press_mesg.each_with_index do | mesg, i |
      next if !mesg || mesg.size == 0
      Ncurses.wattron( window, A_REVERSE ) if ( i == 1 ) || ( i == 3 )
      Ncurses.waddstr( window, mesg )
      Ncurses.wattroff( window, A_REVERSE ) if ( i == 1 ) || ( i == 3 )
    end

    myupdate

    loop { break if mygetc == ESC }

    panel.del
    myupdate
    
  end

  def gold( mesg, amount )

    m_scroll( 3 )
    
    mesg.each_with_index do | str, i |
      Ncurses.mvwaddstr( @message.window, DROWS - 2 + i, 0,
			sprintf( str, amount ) )
    end
    
    multi_cancel
    myupdate
      
  end

  def kick_damage( str, ndamage )

    message( sprintf( str, ndamage ) )
    myupdate

  end

  def learn_spell( format, code, name )
    message( sprintf( format, code, name ) )
  end

  def multi_cancel
    @multi_com  = nil
    @multi_times = 0
  end

  def opening( mesg_array, press )
    
    panel  = makepanel( DROWS, DCOLS, 0, 0 )
    window = panel.window

    Ncurses.wattron( window, Ncurses::A_BOLD )
    
    mesg_array.each_with_index do | str, i |
      Ncurses.mvwaddstr( window, i, 0, str )
    end

    Ncurses.wmove( window, DROWS - 1, 0 )

    press.each_with_index do | str, i |
      Ncurses.wattron( window, Ncurses::A_REVERSE ) if i == 1
      Ncurses.waddstr( window, str )
      Ncurses.wattroff( window, Ncurses::A_REVERSE ) if i == 1
    end

    
    myupdate
    mygetc

    panel.del
    myupdate

  end

  BACKSPACE =   8
  ESC       =  27
  DELETE    = 127

  def altar_get_amount( mesg ) ; get_amount( @message, mesg ) ; end

  alias_method( :drop_get_amount,  :altar_get_amount )
  alias_method( :debug_get_amount, :altar_get_amount )

  
  # ۤϤ롣
  def get_amount( panel, mesg )

    if panel == @message
      message( mesg )
    else
      store_message( mesg )
    end


    window = panel.window
    
    # ncurses-ruby饤֥ϡgetyxΰμ߷פѡ
    window.getyx( row = [], col = [] )

    amount = 0
    
    loop do

      com = mygetc
    
      if com == ESC # ϥ󥻥롣
	return( 0 )
      elsif com == BACKSPACE || com == DELETE
	amount = ( amount / 10 )
	Ncurses.wmove( window, row[ 0 ], col[ 0 ] )
	
	Ncurses.wclrtoeol( window )
	Ncurses.waddstr( window, amount.to_s )  if amount > 0
	myupdate
      elsif com.between?( ?0, ?9 )
	next if amount > 1000000
	amount = amount * 10 + com - ?0
	Ncurses.waddstr( window,  com.chr )
	myupdate
      elsif com == ?\n
	return amount
      end
      
    end

  end

  def get_direction( mesg )

    message( mesg )
    
    # ѤϤޤǡ֤
    loop do
       if DIRS.include?( dir = mygetc ) ; return( dir ) ; end
    end

  end
  
  def get_spell( enter_spell, aborted, header, list, press_space )

    message( enter_spell )

    spell = ""
    
    3.times do | i |

      input = mygetc

      if ( i == 0 ) && ( input == ?D )
	show_found_list( header, list, press_space )
	redo
      elsif input == ?\e
	add_message( aborted )
	return nil
      elsif input.between?( ?a, ?z ) || input.between?( ?A, ?Z )
	spell << input.chr
      end
      
    end
    
    spell
    
  end

  # 3ȤߤˤȤɬפʥ

  # [ "", "ǥ", "å", "", "륿" ]ȡ

  #     ǥ   å
  #     륿

  # Ȥˡ5 / 3 + 1 = 2 ɬפˤʤޤ
  
  def three_column_rows( size )
    size / 3 + ( ( ( size % 3 ) == 0 ) ? 0 : 1 )
  end

  def entry_to_string( entry )

    if entry.is_a?( String )
      entry
    elsif entry.is_a?( Array ) && ( entry.size == 2 )
      sprintf( "%s %s", *entry )
    end

  end

  SPELL_OFFSET = [ 0, 27, 54 ]
    
  def show_found_list( header, list, press_space )

    # list:
    # list = [ "enchant armor", "enchant weapon", ....,  ]

    rows = 4 + three_column_rows( list.size )

    panel = makepanel( rows, DCOLS, 0, 0 )
    win   = panel.window

    Ncurses.wattron( win, A_BOLD | A_BLINK )
    Ncurses.redrawwin( win ) if $REDRAW
    
    # Ǿʤ˥å
    Ncurses.mvwaddstr( win, 0, 0, header )

    # ꥹȤȤߤɽ
    list.each_with_index do | entry, i |
      Ncurses.mvwaddstr( win, 2 + i/3, SPELL_OFFSET[ i % 3 ],
			entry_to_string( entry ) )
    end

    Ncurses.wattroff( win, A_BLINK )
    
    # ǲʤ press space to continue
    write_press_space( win, rows - 1, press_space )

    myupdate

    mygetc

    panel.delete

    myupdate
    
  end

  # Ի󥹥Ρե٥åȥɤϤ롣
  def get_genocide( mesg )

    message( mesg )

    loop do
      
      char = mygetc
      next if !( char.between?( ?a, ?z ) ) && !( char.between?( ?A, ?Z ) )

      Ncurses.waddstr( @message.window, char.chr )
      myupdate

      return char

    end

  end

  # ߤޤǤȯ̤ˡʪΥꥹȤ
  # ֤ɽޤ
  
  def all_item_found( m_header, m_list, s_header, s_list, p_header, p_list,
		     press_space )

    # header:
    # ʸ"The magic spells you have discovered thus far:"ʤɡ

    # list: ˡξ硣
    # ηΡޤǤ
    # [ [ "pro",         "protection"    ],
    #   [ "mle",         "magic missile" ],
    #   [ ˡΥɡ ˡ      ], ] 

    # list: ʪξ
    # [ "enchant armor", "echantweapon", ... ]
    
    show_found_list( m_header, m_list, press_space ) # ˡ
    show_found_list( s_header, s_list, press_space ) # ʪ
    show_found_list( p_header, p_list, press_space ) # 

  end

  def tradepost( mesg )
    makestore( 7, mesg )
  end

  def tradepost_question( mesg )

    s_scroll

    win = @store_message.window

    Ncurses.wmove( win, DROWS - 1, 0 )
    
    mesg.each_with_index do | string, i |
      Ncurses.wattron( win, A_REVERSE ) if i == 2 || i == 4
      Ncurses.waddstr( win, string )
      Ncurses.wattroff( win, A_REVERSE ) if i == 2 || i == 4
    end

    myupdate

    loop do
      com = mygetc
      return com if com == ?\e || com == ?* || com.between?( ?a, ?z )
    end

  end
  
  def store_item( item_format )
    store_message( format2str( item_format ) )
  end

  alias_method( :tradepost_item, :store_item )
  alias_method( :dndstore_item,  :store_item )

  def tradepost_sell( mesg, answer_hash )

    tradepost_message( mesg )

    window = @store_message.window
    
    loop do 
      next unless answer_hash.key?( com = mygetc )

      Ncurses.waddstr( window, answer_hash[ com ] )
      return com

    end

  end

  def store_exit
    
    Ncurses.curs_set( 1 )

    @store_main.delete
    @store_message.delete

    myupdate
    
  end

  alias_method( :tradepost_exit, :store_exit )
  alias_method( :dndstore_exit,  :store_exit )
  alias_method( :school_exit,    :store_exit )
  
  alias_method( :tradepost_message, :store_message )
  alias_method( :dndstore_message,  :store_message )
  alias_method( :school_message,    :store_message )
  
  def makestore( main_rows, mesg )

    Ncurses.curs_set( 0 )
    
    @store_message = makepanel( DROWS,     DCOLS, 0, 0 ) 
    @store_main    = makepanel( main_rows, DCOLS, 0, 0 )
    
    window = @store_main.window

    Ncurses.wattron( window, A_BOLD )
    Ncurses.wattron( @store_message.window, A_BOLD )
    
    mesg.each_with_index do | string, i |
      Ncurses.mvwaddstr( window, i, 0, string ) if string
    end
    
  end

  def dndstore_tax( tax_mesg, press_escape )

    window = @store_main.window
    
    tax_mesg.each_with_index do | string, i |
      Ncurses.mvwaddstr( window, 4 + i, 0, string )
    end

    myupdate

    store_standout_write( press_escape, [ 1 ] )
    mygetc
    
  end

  def dndstore( mesg )
    makestore( 18, mesg )
  end

  def dndstore_money( gold )
    Ncurses.mvwaddstr( @store_main.window, 17, 50, gold )
  end

  def dndformat2str( dndformat )
    sprintf( "%c) %-28s%6s", *dndformat )
  end
  
  def dndstore_choose( list, mesg )

    window = @store_main.window
    
    # ľΥꥹȤõ
    13.times do | i |
      Ncurses.wmove( window, i + 4, 0 )
      Ncurses.wclrtoeol( window )
    end

    list.each_with_index do | dndformat, i |
      next unless dndformat
      Ncurses.mvwaddstr( window, i / 2 + 4, ( i % 2 ) * 40,
			dndformat2str( dndformat ) )
    end

    Ncurses.redrawwin( window ) if $REDRAW
        
    store_standout_write( mesg, [ 2, 4 ] )

    loop do
      com = mygetc
      return( com ) if com == ?\e || com == ?\s || com.between?( ?a, ?z )
    end
        
  end

  alias_method( :tradepost_all_item, :all_item )

  def school( welcome, cost )
    makestore( 18, welcome )
    Ncurses.mvwaddstr( @store_main.window, 15, 16, cost )
  end

  def store_standout_write( mesg, to_standout = [] )

    s_scroll

    win = @store_message.window
    Ncurses.wmove( win, DROWS - 1, 0 )

    mesg.each_with_index do | string, i |
      Ncurses.wattron( win, A_REVERSE ) if to_standout.include?( i )
      Ncurses.waddstr( win, string )
      Ncurses.wattroff( win, A_REVERSE ) if to_standout.include?( i )
    end

    myupdate
    
  end  
  
  def school_course( header, course, mesg )

    s_win = @store_main.window
    
    Ncurses.mvwaddstr( s_win, 4, 20, header )
       
    course.each_with_index do | string, i |
      Ncurses.wmove( s_win, 6 + i, 16 )
      Ncurses.wclrtoeol( s_win )
      Ncurses.waddstr( s_win, string ) if string
    end
    
    # 939 "What is your choice "
    # 940 "["
    # 941 "escape" # ȿž
    # 942 " to leave"
    # 943 "] ? "

    store_standout_write( mesg, [ 2 ] )

    loop do
      com = mygetc
      return( com ) if com == ?\e || com.between?( ?a, ?h )
    end
    
  end

  def school_money( money )
    Ncurses.mvwaddstr( @store_main.window, 17, 30, money )
    myupdate
  end

 
  # lrs  
 
   def lrs( mesg )
    makestore( 6, mesg )
  end

  def lrs_tax( tax_string )

    window = @store_main.window
    
    Ncurses.wmove( window, 3, 0 )
    Ncurses.wclrtoeol( window )
    Ncurses.mvwaddstr( @store_main.window, 3, 0, tax_string )
    Ncurses.wredrawln( window, 3, 0 ) if $REDRAW
  
    myupdate
    
  end

  def lrs_money( money_string )

    window = @store_main.window
    
    Ncurses.wmove( window, 5, 0 )
    Ncurses.wclrtoeol( window )
    Ncurses.mvwaddstr( @store_main.window, 5, 0, money_string )
    Ncurses.wredrawln( window, 5, 0 ) if $REDRAW
    
    myupdate
    
  end

  def lrs_command( mesg, command_hash )

    # mesg:    
    # 972 "Your wish? "
    # 973 "["
    # 974 ("
    # 975 "p" # Ĵɽ
    # 976 ")"
    # 977 " pay taxes, or "
    # 978 "escape" # Ĵɽ
    # 979 "]  "

    store_standout_write( mesg, [ 3, 6 ] )
    window = @store_message.window
    
    loop do

      if ( com = mygetc ) == ?\t
	store_main_hide
	next
      end
      
      next unless command_hash.key?( com )

      Ncurses.waddstr( window, command_hash[ com ] )
      myupdate

      return( com )

    end

  end

  alias_method( :lrs_message, :store_message )
  alias_method( :lrs_exit, :store_exit )

    
  def lrs_pay_taxes( how_much )
    get_amount( @store_message, how_much )
  end

  def store_main_hide

    @store_main.hide
    myupdate

    mygetc
    
    @store_main.show
    myupdate
    
  end

  # bank
  
  def bank( mesg )
    makestore( 18, mesg )
  end

  alias_method( :bank_exit,    :store_exit )
  alias_method( :bank_message, :store_message )

  def bank_pay_taxes( mesg, press_escape )

    # 1181 "Press "
    # 1182 "escape"
    # 1183 " to leave: "

    window = @store_main.window
    
    mesg.each_with_index do | string, i |
      Ncurses.mvwaddstr( window, 2 + i, 0, string )
    end

    myupdate

    store_standout_write( press_escape, [ 1 ] )

    mygetc

  end

  def bank_bankaccount( bankaccount )
    Ncurses.mvwaddstr( @store_main.window, 16, 30, bankaccount )
    myupdate
  end

  def bank_gold( gold )
    Ncurses.mvwaddstr( @store_main.window, 17, 39, gold )
    myupdate
  end

  def gemformat2str( gemformat )
    sprintf( "%c) %-28s %7d ", *gemformat )
  end
  
  
  def bank_gemlist( header, gemlist )

    win = @store_main.window
    
    Ncurses.mvwaddstr( win, 2, 0, header )

    gemlist.each_with_index do | gemformat, i |
      Ncurses.wmove( win, 3 + i/2, 40 * ( i % 2 ) )
      Ncurses.wclrtoeol( win )
      Ncurses.waddstr( win, gemformat2str( gemformat ) ) if gemformat
    end

    myupdate
        
  end

  def bank_command( command_hash, you_wish )

    # you_wish:
    
    # 1190 "Your wish? "
    # 1191 "["
    # 1192 "("
    # 1193 "d" # ȿž
    # 1194 ")"
    # 1195 " deposit, "
    # 1196 "("
    # 1197 "w" # ȿž
    # 1198 ")"
    # 1199 " withdraw, "
    # 1200 "("
    # 1201 "s" # ȿž
    # 1202 ")"
    # 1203 " sell a stone, or "
    # 1204 "escape" # ȿž
    # 1205 "]  "

    store_standout_write( you_wish, [ 3, 7, 11, 14 ] )
    window = @store_message.window
    
    loop do

      next unless command_hash.key?( com = mygetc )
      Ncurses.waddstr( window, command_hash[ com ] )
      myupdate

      return( com )

    end
    
  end

  def bank_get_amount( mesg )
    get_amount( @store_message, mesg )
  end

  def bank_which_stone( which_stone )
    store_message( which_stone )

    loop do
      com = mygetc
      return( com ) if com == ?\e || com.between?( ?a, ?z )
    end

  end

  def side_status( status_array )

    window = @main.window

    Ncurses.wattron( window, A_BOLD )
    
    status_array.each_with_index do | string, i |
      Ncurses.wmove( window, i, 68 )
      Ncurses.wclrtoeol( window )
      Ncurses.waddstr( window, string ) if string 
    end

    Ncurses.wattroff( window, A_BOLD )
    
    cursor_to_player
    myupdate

  end

  def help( first, second, third, fourth, fifth, press_space, press_enter )

    @help = makepanel( DROWS, DCOLS, 0, 0 )
    
    help_write( first,  press_space, [ 1, 3 ] )
    help_write( second, press_space, [ 1, 3 ] )
    help_write( third,  press_space, [ 1, 3 ] )
    help_write( fourth, press_space, [ 1, 3 ] )
    help_write( fifth,  press_enter, [ 1 ]    )

    @help.del
    myupdate
    
  end

  def help_write( mesg_array, press_space, to_standout = [] )

    @help.replace( win = WINDOW.new( DROWS, DCOLS, 0, 0 ) )
    Ncurses.wattron( win, Ncurses::A_BOLD )
    
    mesg_array.each_with_index do | string, i |
      Ncurses.wstandout( win ) if i == 0
      Ncurses.mvwaddstr( win, i, ( i == 0 )? ( DCOLS - string.size ) / 2 :  0,
			string )
      Ncurses.wstandend( win ) if i == 0
    end

    Ncurses.wmove( win, DROWS - 1, 0 )

    press_space.each_with_index do | string, i |
      Ncurses.wstandout( win ) if to_standout.include?( i )
      Ncurses.waddstr( win, string )
      Ncurses.wstandend( win ) if to_standout.include?( i )
    end

    myupdate

    mygetc

  end

  def happy_ending( mesg )

    @ending.top
    myupdate

    window = @ending.window
    
    mesg.each_with_index do | string, i |
      Ncurses.mvwaddstr( window, i, 0, string )
      myupdate
      sleep( 8 ) if string.size > 0
    end

    mygetc
    
  end

  alias_method( :timeover_with_the_potion,    :happy_ending )
  alias_method( :timeover_without_the_potion, :happy_ending )

  def ranking_latest( latest_format, latest_arg )
	
    # ǿλ˴ǡ
    Ncurses.wattron( @ranking.window, A_BOLD )
        
    Ncurses.mvwaddstr( @ranking.window, 0, 0,
		      sprintf( latest_format, *latest_arg ) )

    @ranking.top
    myupdate
    
  end

  def ranking_winner( *arg )

    # ԥ٥8
    ranking_routine( 2, *arg )

  end

  def ranking_routine( offset, header, format, arg_array, empty_string,
		      to_stand_score = nil )

    win = @ranking.window
    
    Ncurses.mvwaddstr( win, offset, 0, header )

    if arg_array.empty?
      Ncurses.mvwaddstr( win, offset + 1, 0, empty_string )
    end
    
    arg_array.each_with_index do | arg, i |
      score  = arg[ 0 ].to_i
      string = sprintf( format, *arg )

      if score == to_stand_score
	string << ( " " * ( DCOLS - string.size ) )
	Ncurses.wattron( win, A_REVERSE )
      end

      Ncurses.mvwaddstr( win, offset + 1 + i, 0, string )

      if score == to_stand_score
	Ncurses.wattroff( win, A_REVERSE )
	to_stand_score = nil
      end

    end

    myupdate
    
  end
  
  def ranking_loser( *arg )
    
    # Լԥ٥8
    ranking_routine( 12, *arg )
    Ncurses.wmove( @ranking.window, DROWS - 1, 0 )
    myupdate
    mygetc
    mygetc
    
  end

  def killed
    sleep 4
  end

  def get_point

    # ruby-ncursesΡgetyxμ
    y = []
    x = []

    window = @main.window
    window.getyx( y, x )

    from = [ y[ 0 ], x[ 0 ] ]
    
    loop do

      if ( com = mygetc ) == ?\e
	return nil
      elsif DIRS.include?( com )
	next if out_of_dungeon?( to = next_point( from, com ) )

	Ncurses.wmove( window, *to )
	myupdate
	return to

      end

    end
    
  end

  def out_of_dungeon?( point )
   !( point[ 0 ].between?( 0, MAXY - 1 ) &&
     point[ 1 ].between?( 0, MAXX - 1 ) )
  end

  def mail( mail_string_array )

    @mail.replace( win = WINDOW.new( DROWS, DCOLS, 0, 0 ) )
    Ncurses.wattron( win, Ncurses::A_BOLD )
    
    mail_string_array.each_with_index do | string, i |
      Ncurses.mvwaddstr( win, i, 0, string )
    end

    @mail.top
    myupdate
    mygetc

  end
  
end
