#! /usr/local/bin/ruby -Ke

require "constant"
require "spell"

class Player

  INITSTATUS = 12
  INITHP = 10
  INITSPELL = 1
  INITLEVEL = 1
  TIMELIMIT = 30000

  include Constant::Object
  include Constant::Player

  MAX_POCKET = 26 # ٤ʪθĿκ͡
  MIN_POCKET = 15 # ٤ʪθĿκǾ͡

  attr_reader :spells, :spellmax, :level, :experience
  attr_reader :hp, :hpmax

  attr_reader :gold
  attr_reader :wield, :shield, :wear, :tax, :bankaccount
  
  attr_accessor :mesg
  attr_reader :name, :screen
  
  def initialize( name )

    @name = name

    # ܥơ
    # ϡѤ3Ĥϡƥˤ롣
    
    @strength     = INITSTATUS
    @intelligence = INITSTATUS
    @dexterity    = INITSTATUS

    @wisdom       = INITSTATUS
    @constitution = INITSTATUS
    @charisma     = INITSTATUS

    @hpmax = INITHP
    @hp    = INITHP

    @gold       = 0
    @experience = 0
    @level      = INITLEVEL

    @spellmax = INITSPELL
    @spells   = INITSPELL

    # 
    @shield = nil
    @wear = nil
    @wield = nil
    
    # ʸ
    @spellknow = []
    
    # ʪ
    @pocket = []

    @gtime = 0

    @status = {}

    @potion = []
    @scroll = []

    @monstkilled = 0 # 󥹥
    @spellscast  = 0
        
    # ʳʸФƤ餷
    learn_spell_id( Constant::Spell::PROTECTION )   # ɸ档
    learn_spell_id( Constant::Spell::MAGICMISSILE ) # ˡΥߥ롣 

    # κǽŪƥ򡢺ǽ餫鼱̤Ƥ餷
    # ȤݥåȤΤˡ˵Ĥι˽ФޤϤϡ
    
    @another_pocket = [ Larnobject.cure_dianthroritis ]
    identify( @another_pocket[ 0 ] )

    @teleflag = false

    @mesg = nil
    @tax = 0
    @bankaccount = 0

    # regenerateѥ󥿡
    @regencounter = 16
    @ecounter     = 96 

    @screen = []
    
  end

  def spell_know?( spell )
    @spellknow[ spell.id ]
  end

  def timeover?
    @gtime > TIMELIMIT
  end

  def learn_spell_id( s_id )
    @spellknow[ s_id ] = true
  end
  
  def learn_spell( spell )
    learn_spell_id( spell.id )
  end

  def forget_spell( spell )
    @spellknow[ spell.id ] = false
  end
  
  
  def initial_equipment

    pack_item( @wear  = Larnobject.new( OLEATHER ) ) 
    pack_item( @wield = Larnobject.new( ODAGGER  ) ) 
    
  end

  def movable?
    !sleep?
  end

  def blindcount? ; @status.include?( BLINDCOUNT ); end
  def hastemonst? ; @status.include?( HASTEMONST ) ; end
  def timestop?   ; @status.include?( TIMESTOP );    end
  def awareness?  ; @status.include?( AWARENESS );   end
  def confuse?    ; @status.include?( CONFUSE );     end
  def wtw?        ; @status.include?( WTW  );        end
  def protectiontime? ; @status.include?( PROTECTIONTIME ) ; end
  def altpro?         ; @status.include?( ALTPRO ) ; end
  def globe?          ; @status.include?( GLOBE ) ; end
  def holdmonst?      ; @status.include?( HOLDMONST ) ; end
  def undeadpro?      ; @status.include?( UNDEADPRO ) ; end
  
    
  def teleflag? ; @teleflag ; end

  def teleport ; @teleflag = true ; end

  def reset_teleflag ; @teleflag = false ; end
  
  def cure_dianthroritis?
    have_type?( :cure_dianthroritis? )
  end
  
  def wizard?


  end

  def id
    @level
  end
  

  # ʪդɤ?
  # ٤ʪκĿϥ٥륢åפȶ˾夬äƤ

  # routine to tell if player can carry one more thing

  def pocketfull?

    # ٤ʪΡĿ׻
    limit = MIN_POCKET + ( @level >> 1 ) 
    limit = MAX_POCKET if limit > MAX_POCKET

    @pocket.each { | obj | limit -= 1 if obj }

    limit < 1
    
  end

  # @pocketξ֤
  # @pocket = [ ƥA, ƥB, nil, ƥD, nil, ... ]
  # ȤʤäƤȤ
  # @pocket = [ ƥA, ƥB, item, ƥD, nil, ... ]
  # Ȥʤ褦˳Ǽ롣
  # Array.pushϻȤʤ
  
  def pack_item( item )

    raise "pocket is full!" if pocketfull?

    MAX_POCKET.times do | i |
      next if @pocket[ i ]
      @pocket[ i ] = item
      return i # index֤
    end
          
  end

  # ˡˤup

  def magic_protect

    value  =  0
    value +=  2 if protectiontime? # ˡProtection
    value +=  3 if altpro?         # Ťŷ˵ä̡
    value += 10 if globe?          # ˡinvulnerability

    value

  end

  def pocket_count( m_id )

    value = 0
    
    @pocket.each do | item |
      next unless item
      value += item.send( m_id )
    end

    value
    
  end
  
  # ϡ
  # Ƥɶ( @wear )ȡ( @shield )ȡɸupƥˤ
  # ӡˡˤup
  
  def ac

    value  = ( @wear ? @wear.ac : 0 ) # 
    value += @shield.ac if @shield    # ⡣
    value += pocket_count( :ac_up )   # ء
    value += magic_protect            # ˡ
    
    ( value > 0 ) ? value : 0
    
  end

  # ϡ
  # Ƥ( @wield )ȡupƥतnιס

  def wclass

    value  = ( @wield ? @wield.wclass : 0 )
    value += pocket_count( :wclass_up )
  
    ( value > 0 ) ? value : 0
        
  end

  def slaying
    pocket_count( :slaying )
  end

  def magic_dexterity
    dexcount? ? 3 : 0
  end

  def magic_strength

    value = 0
    value += hero_status
    value += 21 if giantstr?
    value += 3  if strcount?

    value
    
  end
  
  def strength
    @strength + pocket_count( :strextra ) + magic_strength
  end

  def intelligence
    @intelligence + pocket_count( :intelligence_up ) + hero_status
  end
  
  def dexterity
    @dexterity + pocket_count( :dexterity_up ) + magic_dexterity + hero_status
  end

  def wisdom       ; @wisdom + hero_status       ; end
  def constitution ; @constitution + hero_status ; end
  def charisma     ; @charisma + hero_status     ; end

  def hero_status ; ( hero? ? 11 : 0 ) ; end
  
  def get_gold( amount ) ; @gold += amount ; end

  def item_format( index, object )
    
    array_format = [ ( ?a + index ).chr, objectname( object ), object.enchant ]

    if ( object == @shield ) || ( object == @wear )
      array_format.push( @mesg[ 156 ] )
    elsif ( object == @wield )
      array_format.push( @mesg[ 155 ] )
    end

    array_format
    
  end
  
  def item( object )

    raise if !object || !( @pocket.include?( object ) )
    
    @pocket.each_with_index do | obj, i |
      next unless obj == object
      return item_format( i, object )
    end

  end

  def all_item
    itemlist( true )
  end

  def itemlist( include_money = false )

    items = []
    # ˡ
    items.push( [ ".", @mesg[ 150 ], @gold ] ) if include_money
    
    @pocket.each_with_index do | obj, i |
      next unless obj
      next if block_given? && !yield( obj )
      items.push( item_format( i, obj ) )
    end

    items

  end

  def equip_list
    itemlist { | obj | @wield == obj || @wear == obj || @shield == obj }
  end

  def list_ring
    itemlist{ | obj | obj.ring? }
  end
  
  def list_wearable
    itemlist{ | item | item.wearable? }
  end

  def list_wieldable
    itemlist{ | item | item.wieldable? }
  end

  def list_quaffable
    itemlist{ | item | item.potion? }
  end

  def list_eatable
    itemlist{ | item | item.cookie? }
  end

  def list_readable
    itemlist{ | item | item.readable? }
  end

  
  def mobuls_elapsed
    ( ( elapsed = ( @gtime + 99 ) / 100 + 1 ) < 0 ) ? 0 : elapsed
  end

  def mobuls_left
    ( left = ( TIMELIMIT - @gtime ) / 100 ) < 0 ? 0 : left
  end

  def time_left
    ( TIMELIMIT - @gtime > 0 ) ? ( TIMELIMIT - @gtime ) : 0 
  end
 
  def lose_item( item )

    @pocket.each_with_index do | obj, i |
      next if !obj || item != obj 

      @pocket[ i ] = nil
      @shield = nil if @shield == item
      @wear   = nil if @wear   == item
      @wield  = nil if @wield  == item

      return
    end

    raise "No such item #{ item.id } #{ item.arg }"
    
  end

  def pocket( alpha )
    @pocket[ alpha - ?a ]
  end

  def identified?( obj )

    return scroll_identified?( obj ) if obj.scroll?
    return potion_identified?( obj ) if obj.potion?

    true
    
  end
  
  def scroll_identified?( scroll )
    @scroll[ scroll.arg ]
  end

  def scroll_identified( scroll )
    @scroll[ scroll.arg ] = true
  end

  def potion_identified?( potion )
    @potion[ potion.arg ]
  end

  def potion_identified( potion )
    @potion[ potion.arg ] = true
  end

  def add_status( id, length )

    if @status.key?( id )
      @status[ id ] += length
    else
      @status[ id ] = length
    end
    
  end

  def halfdam?
    @status.include?( HALFDAM )
  end

  def lifeprot?
    @status.include?( LIFEPROT )
  end

  
  def get_terrible_halfdam
    get_halfdam( rnd( 1600 ) + 200 )
  end

  def get_blindcount ; add_status( BLINDCOUNT, 500 ) ; end

  
  def get_hastemonst ; add_status( HASTEMONST, rnd( 55 ) + 12 ) ; end

  def spiritpro?
    @status.include?( SPIRITPRO )
  end
  
  def get_spiritpro ; add_status( SPIRITPRO, 300 + rnd( 200 ) ) ; end
  def get_undeadpro ; add_status( UNDEADPRO, 300 + rnd( 200 ) ) ; end  
  def get_stealth   ; add_status( STEALTH, 250 + rnd( 250 ) )   ; end
  def get_lifeprot  ; add_status( LIFEPROT, 1 ) ; end
  
  def get_holdmonst( n )
    add_status( HOLDMONST, n ) 
  end

  def get_spell_holdmonst ; get_holdmonst( rnd( 10 ) + @level ) ; end

  
  def get_halfdam( n = 200 + rnd( 200 ) )
    add_status( HALFDAM, n )
  end

  def get_awareness( n )
    add_status( AWARENESS, n )
  end

  
  def stealth?
    @status.include?( STEALTH )
  end

  
  def get_itching ; add_status( ITCHING, rnd( 1000 ) + 100 ) ; end
  def get_clumsiness ; add_status( CLUMSINESS, rnd( 1600 ) + 200 ) ; end
  def clumsiness? ; @status.key?( CLUMSINESS ) ; end
  
  def get_confuse( n = 20 + rnd( 9 ) )
    add_status( CONFUSE, n )
  end

  
  def get_aggravate( n = 800 )
    add_status( AGGRAVATE, n )
  end

  def aggravate? ; @status.include?( AGGRAVATE ) ; end

  
  def pit_fall?
    return false unless ( rnd(101)< 81 )
    return ( ( rnd( 70 ) > 9 * dexterity - packweight ) || ( rnd( 101 ) ) < 5 )
  end

  def losemhp( n )

    raise if n < 0
    
    @hp    = 1 if ( @hp    -= n ) < 1
    @hpmax = 1 if ( @hpmax -= n ) < 1

  end

  def losehp( n )

    raise if n < 0
    
    @hp -= n
    
  end

  
  def raisemhp( n )

    raise if n < 0

    @hp    += n
    @hpmax += n

  end

  def raisemspell( n )

    raise if n < 0

    @spells    += n
    @spellmax += n

  end

  def losemspell( n )

    raise if n < 0
    
    @spells   = 0  if ( @spells   -= n ) < 0
    @spellmax = 0  if ( @spellmax -= n ) < 0

  end

  def loselevel

    tmp = ( constitution  - $HARDGAME ) >> 1
    losemhp( rnd( ( tmp > 0 ) ? tmp : 1 ) )
    losemhp( constitution >> 2 ) if ( @level < 7 - $HARDGAME )

    losemspell( rund( 3 ) )

  end

  
  def loseexperience( n )

    raise if n < 0
    
    prelevel = @level
    @experience = 0 if ( ( @experience -= n ) < 0 )
    
    reset_level # иͤäΤǡ٥η׻ľ
    
    ( prelevel - @level ).times { loselevel }
    
  end

  def raiseexperience( n )

    raise if n < 0
    
    prelevel = @level
    @experience += n

    reset_level
    
    ( @level - prelevel ).times { raiselevel }
    
  end

  def raiselevel

    tmp = ( constitution - $HARDGAME ) >> 1
    raisemhp( rnd( 3 ) + rnd( (tmp > 0 ) ? tmp : 1 ) )
    raisemhp( constitution >> 2 ) if ( @level < 7 - $HARDGAME )

    raisemspell( rand( 3 ) )
    
  end

  MEG = 1000000

  SKILL = [    0,      10,      20,      40,      80, #  1-5
             160,     320,     640,    1280,    2560, #  6-10
            5120,   10240,   20480,   40960,  100000, # 11-15
          200000,  400000,  700000,   1*MEG,   2*MEG, # 16-20
           3*MEG,   4*MEG,   5*MEG,   6*MEG,   8*MEG, # 21-25
          10*MEG,  12*MEG,  14*MEG,  16*MEG,  18*MEG, # 26-30
          20*MEG,  22*MEG,  24*MEG,  26*MEG,  28*MEG, # 31-35
          30*MEG,  32*MEG,  34*MEG,  36*MEG,  38*MEG, # 36-40
          40*MEG,  42*MEG,  44*MEG,  46*MEG,  48*MEG, # 41-45
          50*MEG,  52*MEG,  54*MEG,  56*MEG,  58*MEG, # 46-50
          60*MEG,  62*MEG,  64*MEG,  66*MEG,  68*MEG, # 51-55
          70*MEG,  72*MEG,  74*MEG,  76*MEG,  78*MEG, # 56-60
          80*MEG,  82*MEG,  84*MEG,  86*MEG,  88*MEG, # 61-65
          90*MEG,  92*MEG,  94*MEG,  96*MEG,  98*MEG, # 66-70
         100*MEG, 105*MEG, 110*MEG, 115*MEG, 120*MEG, # 71-75
         125*MEG, 130*MEG, 135*MEG, 140*MEG, 145*MEG, # 76-80
         150*MEG, 155*MEG, 160*MEG, 165*MEG, 170*MEG, # 81-85
         175*MEG, 180*MEG, 185*MEG, 190*MEG, 195*MEG, # 86-90
         200*MEG, 210*MEG, 220*MEG, 230*MEG, 240*MEG, # 91-95
         250*MEG, 260*MEG, 270*MEG, 280*MEG, 290*MEG, # 96-100
         300*MEG, # 101
    ]

  MAXPLEVEL = 100

  # ٥ꤷľ
  # ٥MAXPLEVELޤǡ
  
  def reset_level
    
    SKILL.each_with_index do | exp, i |

      if i == MAXPLEVEL
	@level = MAXPLEVEL
	return
      elsif ( @experience >= exp )
	next
      else
	@level = i
	return
      end

    end

  end
  
  def strength_up( n = 1 )     ; @strength += n     ; end
  def intelligence_up( n = 1 ) ; @intelligence += n ; end
  def wisdom_up( n = 1 )       ; @wisdom += n       ; end
  def constitution_up( n = 1 ) ; @constitution += n ; end
  def dexterity_up( n = 1 )    ; @dexterity += n    ; end
  def charisma_up( n = 1 )     ; @charisma += n     ; end

  def can_see_monster?( monst )

    return false if monst.demon? # ɤƤ⡢DEMONϸʤ
    return true  unless monst.invisiblestalker? # ͩʳϸ롣
    return seeinvisible?
    
  end

  def seeinvisible?
    @status.include? SEEINVISIBLE
  end

  def hitchance
    @level + dexterity + wclass / 4 - 12
  end

  def lancedeath?
    @wield && @wield.lance?
  end
  
  # Larn 12.0 Υ˸ΤΡ̤Ѥ°Ǥ
  def moredam
    0
  end


  # 繶ϡ
  def fullhit( monster, n ) # nΨ

    return 0 if ( n < 0 || n > 20 )
    return 100000 if lancedeath?

    hit = n * ( ( wclass >> 1 ) + strength - $HARDGAME -12 + moredam ) 

    if !monster
      ( hit > 0 ) ? hit : 1
    else
      damage_convert( monster, hit )
    end

  end

  def damage_convert( monster, damage )
    
    # halfdamδ֤ϥ᡼Ⱦʬˡ
    damage = ( damage >> 1 ) if halfdam?
    damage *= ( 1 + ( slaying << 1 ) ) if monster.dragon? # ε
    
    return( ( damage > 0 ) ? damage : 1 )

  end
  
  def hitdamage( monster, n = 1 ) # nΨ

    if ( damage = fullhit( nil, n ) ) < 9999
      damage = rnd( damage ) + 1
    end

    damage_convert( monster, damage )
    
  end

  def spell_damage( monster, damage )
    damage_convert( monster, damage )
  end


 
  def monstername( monster )

    return( @mesg[ 520 ] ) if blindcount? 
    real_monstername( monster )

  end

  alias_method( :monster_call, :monstername )
  
  def real_monstername( monster )
    @mesg[ 450 + monster.id ]
  end

  def real_monstername_id( id )
    @mesg[ 450 + id ]
  end
  

  def weapon_dulled

    return unless @wield

    @wield.weapon_dulled

  end

  def break_holdmonst
    @status[ HOLDMONST ] = 1 if holdmonst?
  end

  def monstkilled
    @monstkilled += 1
  end

  def objectname( object )

    if object.scroll? && scroll_identified?( object )
      @mesg[ 540 + object.arg ]
    elsif object.potion? && potion_identified?( object )
      @mesg[ 600 + object.arg ]
    else
      id2objectname( object.id )
    end

  end

  def id2objectname( id )
    @mesg[ 50 + id ]
  end
  
  def enchant_armor

    if @wear # ͥ衣
      @wear.enchanted
    elsif @shield # Ƥ餺Ƥʤ...
      @shield.enchanted
    end

  end

  # LarnǤϻؤʤɤȤǤޤա
  def enchant_weapon
    @wield.enchanted if @wield
  end

  def wield? ; @wield ; end
  
  # ֤ФĤȶˡäƤޤ°
  TIME_CHANGE = [
    HASTESELF,
    HERO,
    ALTPRO,
    PROTECTIONTIME,
    DEXCOUNT,
    STRCOUNT,
    GIANTSTR,
    CHARMCOUNT,
    INVISIBILITY,
    CANCELLATION,
    HASTESELF,
    AGGRAVATE,
    SCAREMONST,
    STEALTH,
    AWARENESS,
    HOLDMONST,
    HASTEMONST,
    FIRERESISTANCE,
    GLOBE,
    SPIRITPRO,
    UNDEADPRO,
    HALFDAM,
    SEEINVISIBLE,
    ITCHING,
    CLUMSINESS,
    WTW,
    SLEEP,
    ]

  # gtime > 0ΤȤ֤ʤࡣ
  # gtime < 0ΤȤ֤롣
  
  def time_warp( gtime )

    @gtime += gtime
    adjust_time( gtime )
      
  end
  
  # ü쥹ơθ̻֤ΡĤĤ޹碌
  def adjust_time( time )
 
    @status.keys.each do | key |
      @status[ key ] -= time if TIME_CHANGE.include?( key )
    end
    
  end

  def gem_perfection

    @pocket.each do | item |
      next if !item || !item.gem?
      item.gem_perfection
    end

  end

  # spell_extensionǡƶˡ
  
  EXTENSION = [
    PROTECTIONTIME,
    DEXCOUNT,
    STRCOUNT,
    CHARMCOUNT,
    INVISIBILITY,
    CANCELLATION,
    HASTESELF,
    GLOBE,
    SCAREMONST,
    HOLDMONST,
    TIMESTOP
    ]

  def spell_extension

    @status.keys.each do | status |
      next unless EXTENSION.include?( status )
      @status[ status ] = ( @status[ status ] << 1 ) # ̻֤ܤˡ
    end
    
  end

  def identify( object )
    
    # ʪȿ̡
    scroll_identified( object ) if object.scroll?
    potion_identified( object ) if object.potion?

  end
  
  def all_identify # ʪ̡
    
    @pocket.each do | object |
      identify( object ) if object
    end

  end

  # ʲü쥹ơϡˤʤޤ
  # remove_curseδʪǡΥơ۾ݤǤޤ
  
  CURSE = [
    BLINDCOUNT,
    CONFUSE,
    AGGRAVATE,
    HASTEMONST,
    ITCHING,
    LAUGHING,
    DRAINSTRENGTH,
    CLUMSINESS,
    INFEEBLEMENT,
    HALFDAM
  ]

  def remove_curse

    CURSE.each do | status |

      next unless @status.key?( status )

      @status[ status ] = 1 # regenκݤˡ0ˤʤޤ

    end
    
  end

  def get_sleep( n = ( rnd( 11 ) -  ( constitution >> 2 ) + 2 ) )
    add_status( SLEEP, n )
  end

  def sleep?
    @status.include?( SLEEP )
  end

  def potion_healing

    if @hp == @hpmax
      raisemhp( 1 )
    else
      healing( rnd( 20 ) + 20 + @level )
    end

  end

  def healing( n )
    
    raise if n < 0
    @hp = @hpmax if ( @hp += n ) > @hpmax

  end

  def spell_healing ; healing( 20 + @level << 1 ) ; end

  MAXLEVEL = 100
  
  def potion_raiselevel

    if @level < MAXLEVEL
      @experience = SKILL[ @level ]
      reset_level
    end
      
    raiselevel
    raisemhp( 1 ) # ʬŵ

  end

  def increase_ability

    case rand( 6 )
    when 0
      @strength += 1
    when 1
      @intelligence += 1
    when 2
      @dexterity += 1
    when 3
      @wisdom += 1
    when 4
      @constitution += 1
    when 5
      @charisma += 1
    end
    
  end

  def potion_wisdom ; @wisdom += rnd( 2 ) ; end

  def potion_strength
    @strength = INITSTATUS if ( ( @strength += 1 ) < INITSTATUS )
  end
  
  def raise_charisma ; @charisma += 1 ; end
  def dizziness ; @strength = 3 if ( ( @strength -= 1 ) < 3 ) ; end
  def learning ; @intelligence += 1 ; end

  def hero? ; @status.include?( HERO ) ; end
  def get_hero ; add_status( HERO, 250 ) ; end

  def giantstr? ; @status.include?( GIANTSTR ) ; end
  def get_giantstr ; add_status( GIANTSTR, 700 ) ; end

  def fireresistance? ; @status.include?( FIRERESISTANCE ) ; end
  def get_fireresistance ; add_status( FIRERESISTANCE, 1000 ) ; end

  def instant_healing ; @hp = @hpmax ; end

  def get_seeinvisible ; add_status( SEEINVISIBLE, rnd( 1000 ) + 400 ) ; end

  def spell_list

    slist = []
    SPNUM.times do | i |
      slist.push( [ Spell::SPELL.id2code( i ), @mesg[ 170 + i ] ] ) if @spellknow[ i ]
    end
    
    slist
        
  end

  def scroll_list # ̤ʪΥꥹȡ

    slist = []
    
    @scroll.each_with_index do | knowflag, index |
      slist.push( @mesg[ 320 + index ] ) if knowflag
    end

    slist

  end
    
  def potion_list # ̤Υꥹȡ

    plist = []
    
    @potion.each_with_index do | knowflag, index |
      plist.push( @mesg[ 570 + index ] ) if knowflag
    end

    plist

  end
  
  
  def spell_cast
    @spellscast += 1
    @spells -= 1
  end

  def spell_fail?
    ( rnd( 23 ) == 7 ) || ( rnd( 18 ) > intelligence )
  end
  
  def inexperienced_for_spell?( spell )
    ( @level * 3 + 2 < spell.id )
  end

  def get_protectiontime; add_status( PROTECTIONTIME, 250 ) ; end

  def get_dexcount ; add_status( DEXCOUNT, 400 ) ; end
  def dexcount? ; @status.include?( DEXCOUNT ) ; end

 

  def sleep_time ; rnd( 3 ) + 1 ; end
  def web_time   ; rnd( 3 ) + 2 ; end
  
  # ʸδܹϡ
  
  def spell_might( spell, s_time = nil )
    
    if spell.sleep? || spell.web?
      fullhit( nil, s_time )
    elsif spell.sonic_spear?
      rnd( 10 ) + 15 + @level
    elsif spell.phantasmal_forces?
      rnd( 20 ) + 20 + @level
    elsif spell.fireball?
      rnd( 25 + @level ) + 25 + @level
    elsif spell.magic_missile?
      rnd( ( @level + 1 ) << 1 ) + @level + 3
    elsif spell.cold?
      rnd( 25 ) + 20 + @level
    elsif spell.cloud_kill?
      30 + rnd( 10 )
    elsif spell.vaporize_rock?
      200
    elsif spell.dehydration?
      100 + @level
    elsif spell.lightning?
      rnd( 25 ) + 20 + @level << 1
    elsif spell.drain_life?
      [ @hp - 1, @hpmax / 2 ].min * 2
    elsif spell.flood?
      32 + @level
    elsif spell.finger_of_death?
      2000
    elsif spell.magic_fire?
      35 + rnd( 10 ) + @level
    elsif spell.summon_demon?
      150
    elsif spell.pulverization?
      150
    else
      0
    end
      
  end

  def get_charmcount
    add_status( CHARMCOUNT, charisma << 1 )
  end

  def charmcount? ; @status.include?( CHARMCOUNT ) ; end

  def get_strcount
    add_status( STRCOUNT, 150 + rnd( 100 ) )  
  end

  def strcount? ; @status.include?( STRCOUNT ) ; end

  def reset_status( id )

    return unless @status.include?( id )
    @status[ id ] = 0
    
  end

  def lose_blindcount ; reset_status( BLINDCOUNT ) ; end

  def phantasmal_forces_fail?
    !( rnd( 11 ) + 7 <= wisdom )
  end

  def invisibility? ; @status.include?( INVISIBILITY ) ; end

  def add_invisibility
    add_status( INVISIBILITY, ( pocket_count( :invisibility_up ) << 7 ) + 12 )
  end
  
  def cancellation? ; @status.include?( CANCELLATION ) ; end

  def get_cancellation ; add_status( CANCELLATION, 5 + @level ) ; end

  def get_hasteself ; add_status( HASTESELF, 7 + @level ) ; end
  def hasteself? ; @status.include?( HASTESELF ) ; end
  
  
  def get_globe; add_status( GLOBE, 200 ) ; end

  # ˡfinger_of_deathѡ
  def self_finger_of_death? ; rnd( 151 ) == 63 ; end

  def finger_of_death_fail? ;  !( wisdom > rnd( 10 ) + 10 ) ; end

  def scaremonst? ; @status.include?( SCAREMONST ) ; end
  def get_scaremonst ; add_status( SCAREMONST, rnd( 10 ) + @level ) ; end
  
  def get_timestop ; add_status( TIMESTOP, rnd( 20 ) + ( @level << 1 ) ) ; end


  # ˡsphere_of_annihilation

  def self_sphere_of_annihilation? ; ( rnd( 23 ) == 5 ) && !wizard? ; end 
  def sphere_life ; rnd( 20 ) + 11 ; end
    
  def lose_intelligence
    @intelligence = 3 if ( @intelligence -= 1 ) < 3
  end

  def lose_holdmonst
    @status[ HOLDMONST ] = 0 if holdmonst?
  end

  def lose_cancellation
    @status[ CANCELLATION ] = 0 if cancellation?
  end

 # ˡsummon demon:

  def summon_demon_fail? ; !( rnd( 100 ) > 30 ) ; end

  # ˡԤݤˡʬ⤵뤫ɤ?
  def self_summon_demon? ; !( rnd( 100 ) > 15 ) ; end 
  def self_summon_demon_damage ; rnd( 40 ) + 30 ; end

  def get_wtw ; add_status( WTW, rnd( 10 ) + 5 ) ; end
  
  def monster_can_move?

    # timestopϹưԲġ
    return false if timestop?

    # hasteselfϡ2˰γǤưʤ?
    return false if hasteself? && ( ( @status[ HASTESELF ] & 1 ) == 0 )

    # holdmonsterϹưԲġ
    return false if holdmonst?

    true
    
  end

  def monster_must_stop?( monster )
    monster.slow? && ( ( @gtime & 1 ) == 1 ) # 0
  end

  def regenerate_monster? ; ( @gtime & 1 ) == 0 ; end

  def have_type?( method )
    @pocket.each { | item | return true if item && item.send( method ) }
    false
  end
  
  def anti_spritual?
    have_type?( :spiritscarab? ) || spiritpro?
  end

  def anti_undead?
    have_type?( :cubeofundead? ) || undeadpro?
  end

  def escape_invisibility?
    invisibility? && ( rnd( 33 ) < 20 )
  end

  def escape_charmcount?( monster )
    charmcount? && ( ( rnd( 30 ) + 5 * monster.level - charisma ) < 30 ) 
  end

  def escape_special_attack?( num )
    escape_attack?( num + 8 )
  end

  def escape_attack?( num )

    return false  if ( num > ac )
    return false  if ac == 0
    return false  if ( rnd( ac ) == 1 )

    true
    
  end

  # ζätrue
  # ⤽ƤʤäꡢѲʤȤˤfalse
  
  def shield_eaten ; eaten( @shield ) ; end
  def armor_eaten  ; eaten( @wear )  ; end

  def eaten( obj )

    return false unless obj

    obj_ac = obj.ac
    obj.eaten

    obj_ac != obj.ac

  end

  def strength_down( n = 1 )

    raise if n < 0

    @strength = 3 if ( @strength -= n ) < 3
    
  end

  def drain_level

    return unless @level > 1

    @experience = ( SKILL[ @level - 1 ] - 1 )
    @level -= 1

    loselevel
          
  end

  def notheft?
    have_type?( :notheft? )
  end

  def steal_gold

    if @gold > 32767
      @gold = ( @gold >> 1 )
    else
      @gold -= rnd( 1 + ( @gold >> 1 ) )
    end

    @gold = 0 if @gold < 0

  end

  def disenchantable_item

    50.times do
      next unless ( obj = @pocket[ rand( 26 ) ] )
      next unless ( obj.enchant > 0 )

      return obj
      
    end
    
    nil
    
  end

  def item_for_steal

    100.times do
      next unless ( obj = @pocket[ rand( 26 ) ] )
      next if ( obj == @wield ) || ( obj == @wear ) || ( obj == @shield )

      return obj

    end

    nil

  end
    
  # ˥դ륢ƥब뤫ɤ?
  # Υƥޤʤ
  
  def empty_handed?

    !( @pocket.find { | obj | obj && ( @wield != obj ) && ( @wear != obj ) && ( @shield != obj )  } )
    
  end

  # 櫤Ǥ뤫ɤ?
  # 줿櫤ϡ褱вǤޤ

  def escape_teleporter? ; ( rnd( 11 ) <  6 ) ; end
  def escape_arrow?      ; ( rnd( 17 ) < 13 ) ; end
  def escape_dart?       ; ( rnd( 17 ) < 13 ) ; end
  def escape_door?       ; ( rnd( 17 ) < 13 ) ; end
  
  def course( school )

    unfinished = []
    
    ?a.upto( ?h ) do | i |

      index = i - ?a
      
      if school.finished?( i )
	unfinished[ index ] = nil
      else
	unfinished[ index ] = mesg[ 929 + index ]
      end
      
    end

    unfinished
    
  end

  def time_passed
    @gtime += 1
  end

  def interest
    @bankaccount += ( @bankaccount / 250 ) if ( @gtime % 100 ) == 0 
  end
  
  def lose_gold( n )
    raise if ( n < 0 ) || ( ( @gold -= n ) < 0 ) 
  end

  # College of LanϢ
  
  def fighters_training_I
    @strength     += 2
    @constitution += 1
  end

  def fighters_training_II
    @strength     += 2
    @constitution += 2
  end

  def introduction_to_wizardry ; @intelligence += 2 ; end
  def applied_wizardry         ; @intelligence += 2 ; end
  def behavioral_psychology    ; @charisma     += 3 ; end
  def faith_for_today          ; @wisdom       += 2 ; end
  def contemporary_dance       ; @dexterity    += 3 ; end
  def history_of_larn          ; @intelligence += 1 ; end

  def school_refresh( n_modulo )

    time_warp( n_modulo * 100 )

    @hp     = @hpmax
    @spells = @spellmax

    @status[ BLINDCOUNT ] = 0 if blindcount?
    @status[ CONFUSE ] = 0 if confuse?

  end

  # lrs

  def pay_taxes( n )

    raise if n < 0

    if n > @tax
      raise if ( @gold -= @tax ) < 0
      @tax = 0
    else
      @tax  -= n
      raise if ( @gold -= n ) < 0
    end
        
  end

  def dndname( page, i )
    @mesg[ 1030 + page * 30 + i ]
  end
  
  def dndstore_list( store, page )
    
    # [ [ index, ƥ̾,  ], ... ]
    
    raise unless page.between?( 0, 3 )
    
    dlist = Array.new( 26, nil )
    
    store.arg[ 26 * page, 26 ].each_with_index do | ( price, id, arg, num ), i |
      dlist[ i ] = [ ?a + i, dndname( page, i ), price * 10 ] if num > 0
    end
      
    dlist
    
  end
  
  def deposite( amount ) # Ԥ¶⡣

    raise if ( amount < 0 ) || ( ( @gold -= amount ) < 0 ) 

    @bankaccount += amount

  end

  def withdraw( amount ) # Ԥж⡣

    raise if ( amount < 0 ) || ( ( @bankaccount -= amount ) < 0 )

    @gold += amount
    
  end
  
  def hit_damaged( damage )

    return if ( decrement = ( damage - ac ) ) < 0

    losehp( decrement )
    
  end
  
  def open_success? ; rnd( 11 ) < 7 ; end

  # regenerateκݤˡƶü쥹ơ
  REGENERATE = [
    TIMESTOP,
    HASTESELF,
    HERO,
    ALTPRO,
    PROTECTIONTIME,
    DEXCOUNT,
    STRCOUNT,
    BLINDCOUNT,
    CONFUSE,
    GIANTSTR,
    CHARMCOUNT,
    INVISIBILITY,
    CANCELLATION,
    WTW,
    AGGRAVATE,
    SCAREMONST,
    STEALTH,
    AWARENESS,
    HOLDMONST,
    HASTEMONST,
    FIRERESISTANCE,
    GLOBE,
    SPIRITPRO,
    UNDEADPRO,
    HALFDAM,
    SEEINVISIBLE,
    ITCHING,
    CLUMSINESS,
    SLEEP,
  ]

  # regenerateκݤΡHP̡
  def regen
    1 + pocket_count( :regen_up )
  end

  def energy ; pocket_count( :energy_up ) ; end
  
  def regenerate

    REGENERATE.each { | check | @status[ check ] -= 1 if @status.key?( check ) }
    @status.delete_if { | key, num | num <= 0 }


    if ( @hp != @hpmax ) && ( ( @regencounter -= 1 ) < 1 )
      @regencounter = ( 22 + ( $HARDGAME << 1 ) - @level )
      @hp = @hpmax if ( @hp += regen ) > @hpmax
    end

    if ( @spells != @spellmax ) && ( ( @ecounter -= 1 ) < 1 )
      @ecounter = 100 + 4 * ( $HARDGAME - @level - energy )
      @spells += 1
    end

  end

  # ڤߤȯФ뤫ɤ?
  def itching_unwear?
    ( itching? ) && ( @shield || @wear ) && ( rnd( 100 ) < 50 )
  end

  def itching? ; @status.include?( ITCHING ) ; end
  
  def unwear_all
    @shield = nil
    @wear   = nil
  end

  def clumsiness_drop?
    clumsiness? && @wield && ( rnd( 100 ) < 33 )
  end

  def wear_armor( obj )   ; @wear   = obj ; end
  def wear_shield( obj )  ; @shield = obj ; end
  def wield_weapon( obj ) ; @wield  = obj ; end
    
  def packweight # ȲʪνŤιס
    ( @gold / 1000 ) + pocket_count( :weight )
  end

  def take_off # Ƚæͥ衣

    if @shield
      @shield = nil
    elsif @wear
      @wear = nil
    end

  end

  def gemlist_for_bank

    g_list = Array.new( 26, nil )
    
    @pocket.each_with_index do | item, i |
      next if !item || !( price = item.price_for_bank( @gtime ) )
      g_list[ i ] = [ ?a + i, objectname( item ), price ]
    end

    g_list

  end

  def sellstone( gem )

    lose_item( gem )
    get_gold( gem.price_for_bank( @gtime ) )
    
  end

  def get_altpro ; add_status( ALTPRO, 500 ) ; end
    
  def charge( tax )
    @tax += tax
  end

  def climb_down_damage?
    packweight > ( 45 + 3 * strength ) 
  end

  def climb_up_damage?
    packweight > ( 45 + 5 * strength )
  end

  SIDE_STATUS = [
    :stealth?,
    :undeadpro?,
    :spiritpro?,
    :charmcount?,
    :timestop?,
    :holdmonst?,
    :giantstr?,
    :fireresistance?,
    :dexcount?,
    :strcount?,
    :scaremonst?,
    :hasteself?,
    :cancellation?,
    :invisibility?,
    :altpro?,
    :protectiontime?,
    :wtw?,
  ]

  # ̤αüɽ륹ơ
  # ƥơˤĤơơ۾郎ȯƤʤnil
  
  def side_status

    SIDE_STATUS.dup.collect{ | s_method |
      send( s_method ) ? @mesg[ 1460 + SIDE_STATUS.index( s_method ) ] : nil
    }
    
  end

  def pclass

    case @level
    when 1
      @mesg[ 1480 ] # "  novice explorer  "
    when 2
      @mesg[ 1481 ] # "apprentice explorer"
    when 3
      @mesg[ 1482 ] # " practiced explorer"
    when 4
      @mesg[ 1483 ] # "   expert explorer "
    when 5
      @mesg[ 1484 ] # "  novice adventurer"
    when 6
      @mesg[ 1485 ] # "     adventurer    " # /*  -6*/
    when 7
      @mesg[ 1486 ] # "apprentice conjurer"
    when 8
      @mesg[ 1487 ] # "     conjurer      "
    when 9
      @mesg[ 1488 ] # "  master conjurer  " # /*  -9*/
    when 10
      @mesg[ 1489 ] # "  apprentice mage  "
    when 11
      @mesg[ 1490 ] # "        mage       "
    when 12
      @mesg[ 1491 ] # "  experienced mage " # /* -12*/
    when 13
      @mesg[ 1492 ] # "     master mage   "
    when 14
      @mesg[ 1493 ] # " apprentice warlord"
    when 15
      @mesg[ 1494 ] # "   novice warlord  "
    when 16
      @mesg[ 1495 ] # "   expert warlord  "
    when 17
      @mesg[ 1496 ] # "   master warlord  "
    when 18
      @mesg[ 1497 ] # " apprentice gorgon " # /* -18*/
    when 19
      @mesg[ 1498 ] # "       gorgon      "
    when 20
      @mesg[ 1499 ] # "  practiced gorgon "
    when 21
      @mesg[ 1500 ] # "   master gorgon   " # /* -21*/
    when 22
      @mesg[ 1501 ] # "    demi-gorgon    "
    when 23
      @mesg[ 1502 ] # "    evil master    "
    when 24
      @mesg[ 1503 ] # " great evil master " # /* -24*/
    when ( 25 .. 39 )
      @mesg[ 1504 ] # " mighty evil master"
    when ( 40 .. 48 )
      @mesg[ 1505 ] # "apprentice demi-god"
    when ( 49 .. 57 )
      @mesg[ 1506 ] # "  minor demi-god   "
    when ( 58  ..66 )
      @mesg[ 1507 ] # "  major demi-god   "
    when ( 67 .. 75 )
      @mesg[ 1508 ] # "    minor deity    "
    when ( 76 .. 84 )
      @mesg[ 1509 ] # "    major deity    "
    when ( 85 .. 87 )
      @mesg[ 1510 ] # "  novice guardian  "
    when ( 88 .. 93 )
      @mesg[ 1511 ] # "apprentice guardian"
    when 94
      @mesg[ 1512 ] # "  earth guardian   "
    when 95
      @mesg[ 1513 ] # "   air guardian    "
    when 96
      @mesg[ 1514 ] # "   fire guardian   " # /* -96*/
    when 97
      @mesg[ 1515 ] # "  water guardian   "
    when 98
      @mesg[ 1516 ] # "  time guardian    "
    when 99
      @mesg[ 1517 ] # " ethereal guardian " # /* -99*/
    when ( 100 .. 102 )
      @mesg[ 1518 ] # "    The Creator    "
    else
      "Bug Bug Bug Bug    "
    end
    
  end

  def status1
    [ @spells, @spellmax,   # ʸ
      ac,      wclass,      # ɸϡϡ
      @level,  @experience, # ٥롢и͡
      pclass                # ι档
      ]
  end

  def caveclass( clevel )
    ( teleflag? ) ? @mesg[ 1534 ] : @mesg[ 1520 + clevel ] 
  end
  
  # ϡ6ơ⡣
  def status2( clevel )
    [ @hp, @hpmax,
      strength, intelligence, wisdom, constitution, dexterity, charisma,
      caveclass( clevel ),
      @gold ]
  end

  def resuscitated

    raise unless @status.key?( LIFEPROT )

    @status.delete( LIFEPROT ) if ( @status[ LIFEPROT ] -= 1 ) < 1
    @hp = 1
    @constitution -= 1
    
  end

  # ˴ݤΥϡ¶ιס٤ˤܡʥ
  
  def all_gold ; @gold + @bankaccount ; end
  def score ; all_gold + ( killed? ? 0 : 100000 * $HARDGAME ) ; end
  def mobuls2gold ; mobuls_left * 1000 ; end

  # RubyLarnǤϡ + ¶ + ٥ܡʥ + Ĥ֡
  def score_with_time ; score + mobls2gold ; end
  
  # ݤˡ⻺(score)˱Ƕ򤫤ޤ
  TAXRATE = 20

  # ܡʥǶоݳ
  def score2tax
    all_gold / TAXRATE
  end
  
  def killed?
    @hp <= 0
  end

  def annihilated
    @hp = 0
  end

  alias_method( :bottomless_pit,       :annihilated )
  alias_method( :solid_rock,           :annihilated )
  alias_method( :suicide,              :annihilated )
  alias_method( :wayward_finger,       :annihilated )
  alias_method( :bottomless_trap_door, :annihilated )
  alias_method( :dreadful_sleep,       :annihilated )

  # ʪʤɤȤ鷺ˡƥݡȽ뤫ɤ?
  # LarnħΰĤǤ
  
  def enable_teleport?
    @level > 9
  end

  def learn_all_spell
    Constant::SPNUM.times do | sid | learn_spell_id( sid ) end
  end

  def identify_all_scroll
    Constant::MAXSCROLL.times { | arg | @scroll[ arg ] = true }
  end

  def identify_all_potion
    Constant::MAXPOTION.times { | arg | @potion[ arg ] = true }
  end
  
end
