#! /usr/local/bin/ruby -Ke

def readrc(path)

  conflist = {}
  name = password = server = port = nil

  File.foreach(path) do |line|
    next if line =~ /^\s*\#/ or line !~ /\S+/
    key, val = line.chomp.split("=", 2).collect { |s| s.strip }
    conflist[key] = val
  end

  config = ["name", "password", "server", "port"].collect { |k| conflist[k] }
  raise "եεҥߥ" if config.include?(nil)
  config

end

def name_check( name )
  name && ( name.size > 0 ) && ( name.size < 16 )
end

def password_check( password )
  password && ( password.size >= 8 ) && ( password.size <= 64 )
end

def port_check( port )
  port && port.size > 0
end

def server_check( server )
  server && server.size > 0
end

