require "constant"

module Resist

  include Constant::Monster
  
  # 󥹥ˡɽ
  # 0: ˡͭ
  # ʳ: ˡ̵

  RESIST_MAGIC_MISSILE = {
    HELLHOUND      =>  6, 
    TROLL          =>  7,
    METAMORPH      => 13,
    VORTEX         => 13,
    ROTHE          =>  7,
    XORN           =>  7,
    POLTERGEIST    => 13,
    UMBERHULK      =>  7,
    GNOMEKING      =>  7,
    WATERLORD      => 13,
    BRONZEDRAGON   =>  7,
    GREENDRAGON    =>  7,
    SPIRITNAGA     => 13,
    SILVERDRAGON   =>  6,
    PLATINUMDRAGON =>  7,
    REDDRAGON      =>  6,
    DEMONLORD_1    =>  7,
    DEMONLORD_2    =>  7,
    DEMONLORD_3    =>  7,
    DEMONLORD_4    =>  7,
    DEMONLORD_5    =>  7,
    DEMONLORD_6    =>  7,
    DEMONLORD_7    =>  7,
    DEMONPRINCE    =>  7,
  }

  RESIST_SLEEP = {
    ZOMBIE           => 8,
    WRAITH           => 8,
    VAMPIRE          => 8,
    POLTERGEIST      => 8,
    DISENCHANTRESS   => 8,
    YELLOWMOLD       => 8,
    WATERLORD        => 8,
    SPIRITNAGA       => 8,
    SILVERDRAGON     => 9,
    PLATINUMDRAGON   => 9,
    DEMONLORD_1      => 4,
    DEMONLORD_2      => 4,
    DEMONLORD_3      => 4,
    DEMONLORD_4      => 4,
    DEMONLORD_5      => 4,
    DEMONLORD_6      => 4,
    DEMONLORD_7      => 4,
    DEMONPRINCE      => 4,
  }

  RESIST_CHARM_MONSTER = {
    GNOMEKING        =>  3,
    WATERLORD        =>  3,
    SPIRITNAGA       =>  3,
    DEMONLORD_1      =>  3,
    DEMONLORD_2      =>  3,
    DEMONLORD_3      =>  3,
    DEMONLORD_4      =>  3,
    DEMONLORD_5      =>  3,
    DEMONLORD_6      =>  3,
    DEMONLORD_7      =>  3,
    DEMONPRINCE      =>  3,
  }

  RESIST_SONIC_SPEAR = {
    ZOMBIE           =>  4,
    VORTEX           => 10,
    WRAITH           =>  4,
    VAMPIRE          =>  4,
    POLTERGEIST      =>  4,
    SHAMBLINGMOUND   => 10,
    WATERLORD        =>  4,
    SPIRITNAGA       =>  4,
    DEMONPRINCE      =>  9,
  }
  
  RESIST_WEB = {
    HELLHOUND        => 12,
    ICELIZARD        => 11,
    CUBE             =>  2,
    METAMORPH        =>  2,
    VORTEX           =>  1,
    INVISIBLESTALKER =>  1,
    POLTERGEIST      =>  1,
    YELLOWMOLD       =>  1,
    WATERLORD        =>  1,
    GREENDRAGON      => 11,
    SPIRITNAGA       =>  1,
    SILVERDRAGON     => 12,
    PLATINUMDRAGON   => 11,
    REDDRAGON        => 12,
    DEMONLORD_1      =>  1,
    DEMONLORD_2      =>  1,
    DEMONLORD_3      =>  1,
    DEMONLORD_4      =>  1,
    DEMONLORD_5      =>  1,
    DEMONLORD_6      =>  1,
    DEMONLORD_7      =>  1,
    DEMONPRINCE      =>  1,
  }

  RESIST_PHANTASMAL_FORCES = {
    WHITEDRAGON      => 14,
    ELF              => 14,
    YELLOWMOLD       =>  4,
    PLATINUMDRAGON   => 14,
    DEMONLORD_1      => 14,
    DEMONLORD_2      => 14,
    DEMONLORD_3      => 14,
    DEMONLORD_4      => 14,
    DEMONLORD_5      => 14,
    DEMONLORD_6      => 14,
    DEMONLORD_7      => 14,
    DEMONPRINCE      => 14,
  }

  RESIST_INVISIBILITY = {
    GNOME            =>  5,
    KOBOLD           =>  5,
    BUGBEAR          =>  5,
    TROLL            =>  5,
    ELF              =>  5,
    FORVALAKA        =>  5,
    ROTHE            =>  5,
    XORN             =>  5,
    UMBERHULK        =>  5,
    GNOMEKING        =>  5,
    SPIRITNAGA       =>  5,
    DEMONLORD_1      =>  5,
    DEMONLORD_2      =>  5,
    DEMONLORD_3      =>  5,
    DEMONLORD_4      =>  5,
    DEMONLORD_5      =>  5,
    DEMONLORD_6      =>  5, 
    DEMONLORD_7      =>  5,
    DEMONPRINCE      =>  5,
  }
  
  RESIST_COLD = {
    ICELIZARD        => 15,
    YETI             => 15,
    WHITEDRAGON      => 15,
    POLTERGEIST      =>  4,
    SPIRITNAGA       =>  4,
  }

  RESIST_POLYMORPH = {
    GNOMEKING        =>  9,
    WATERLORD        =>  9,
    SPIRITNAGA       =>  9,
    DEMONLORD_1      =>  4,
    DEMONLORD_2      =>  4,
    DEMONLORD_3      =>  4,
    DEMONLORD_4      =>  4,
    DEMONLORD_5      =>  4,
    DEMONLORD_6      =>  4,
    DEMONLORD_7      =>  4,
    DEMONPRINCE      =>  4,
  }

  RESIST_CLOUD_KILL = {
    ZOMBIE           =>  4,
    CUBE             =>  4,
    METAMORPH        =>  4,
    VORTEX           =>  4,
    WRAITH           =>  4,
    VAMPIRE          =>  4,
    POLTERGEIST      =>  4,
    YELLOWMOLD       =>  4,
    WATERLORD        =>  4,
    SPIRITNAGA       =>  4,
    DEMONLORD_1      =>  4,
    DEMONLORD_2      =>  4,
    DEMONLORD_3      =>  4,
    DEMONLORD_4      =>  4,
    DEMONLORD_5      =>  4,
    DEMONLORD_6      =>  4,
    DEMONLORD_7      =>  4,
    DEMONPRINCE      =>  4,
  }

  RESIST_DEHYDRATION = {
    ORC              =>  4,
    RUSTMONSTER      =>  4,
    ZOMBIE           =>  4,
    TROLL            =>  4,
    WHITEDRAGON      =>  4,
    METAMORPH        =>  4,
    VORTEX           =>  4,
    WRAITH           =>  4,
    XORN             =>  4,
    POLTERGEIST      =>  4,
    SPIRITNAGA       =>  4,
    DEMONLORD_1      =>  4,
    DEMONLORD_2      =>  4,
    DEMONLORD_3      =>  4,
    DEMONLORD_4      =>  4,
    DEMONLORD_5      =>  4,
    DEMONLORD_6      =>  4,
    DEMONLORD_7      =>  4,
    DEMONPRINCE      =>  4,
  }

  RESIST_FLOOD = {
    VORTEX           =>  4,
    POLTERGEIST      =>  4,
    WATERLORD        => 16,
    SPIRITNAGA       =>  4,
    DEMONLORD_1      =>  4,
    DEMONLORD_2      =>  4,
    DEMONLORD_3      =>  4,
    DEMONLORD_4      =>  4,
    DEMONLORD_5      =>  4,
    DEMONLORD_6      =>  4,
    DEMONLORD_7      =>  4,
    DEMONPRINCE      =>  4,
  }

  RESIST_FINGER_OF_DEATH = {
    ZOMBIE           =>  4,
    CUBE             =>  4,
    METAMORPH        =>  4,
    VORTEX           =>  4,
    VIOLETFUNGI      =>  4,
    VAMPIRE          =>  4,
    POLTERGEIST      =>  4,
    YELLOWMOLD       =>  4,
    WATERLORD        =>  4,
    SPIRITNAGA       =>  4,
    DEMONLORD_1      =>  4,
    DEMONLORD_2      =>  4,
    DEMONLORD_3      =>  4,
    DEMONLORD_4      =>  4,
    DEMONLORD_5      =>  4,
    DEMONLORD_6      =>  4,
    DEMONLORD_7      =>  4,
    DEMONPRINCE      =>  4,
  }

  RESIST_SCARE_MONSTER = {
    DEMONPRINCE      =>  4,
  }

  RESIST_MAGIC_FIRE = {
    DEMONPRINCE      =>  4,
  }
  
  RESIST_SPHERE_OF_ANNIHILATION = {
    DEMONLORD_1      =>  9,
    DEMONLORD_2      =>  9,
    DEMONLORD_3      =>  9,
    DEMONLORD_4      =>  9,
    DEMONLORD_5      =>  9,
    DEMONLORD_6      =>  9,
    DEMONLORD_7      =>  9,
    DEMONPRINCE      =>  9,
  }
end
